<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_20) on Tue May 25 22:40:54 CEST 2010 -->
<TITLE>
Matrix
</TITLE>

<META NAME="date" CONTENT="2010-05-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Matrix";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/Matrix.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../org/bitfountain/math/ArrayUtils.html" title="class in org.bitfountain.math"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../org/bitfountain/math/SingularMatrixException.html" title="class in org.bitfountain.math"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?org/bitfountain/math/Matrix.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Matrix.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.bitfountain.math</FONT>
<BR>
Class Matrix</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../resources/inherit.gif" ALT="extended by "><B>org.bitfountain.math.Matrix</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>Matrix</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
A simple 2D matrix, on which we do all kind of operations
 in a given Galois Field.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Amos Wenger, Rivo Vasta</DD>
</DL>
<HR>

<P>
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int[][]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#data">data</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List of rows, address like this: data[row][column].</TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#Matrix(int, int, org.bitfountain.math.reedsolomon.GaloisField)">Matrix</A></B>(int&nbsp;rows,
       int&nbsp;cols,
       <A HREF="../../../org/bitfountain/math/reedsolomon/GaloisField.html" title="class in org.bitfountain.math.reedsolomon">GaloisField</A>&nbsp;pGaloisField)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a new Matrix.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#copyInto(org.bitfountain.math.Matrix, int, int)">copyInto</A></B>(<A HREF="../../../org/bitfountain/math/Matrix.html" title="class in org.bitfountain.math">Matrix</A>&nbsp;destination,
         int&nbsp;rowIndex,
         int&nbsp;colIndex)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Copies a matrix into another greater one.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#copyRowInto(int, org.bitfountain.math.Matrix, int, int)">copyRowInto</A></B>(int&nbsp;sourceRow,
            <A HREF="../../../org/bitfountain/math/Matrix.html" title="class in org.bitfountain.math">Matrix</A>&nbsp;destination,
            int&nbsp;row,
            int&nbsp;column)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Copies a row from a matrix into another one.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#gauss()">gauss</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Naive implementation of Gauss reduction.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#gaussBuster(int)">gaussBuster</A></B>(int&nbsp;identitySize)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Specialized gauss algorithm for matrices that are almost identity.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#getCols()">getCols</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#getRows()">getRows</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#mul(int[], int[])">mul</A></B>(int[]&nbsp;input,
    int[]&nbsp;output)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Multiply a vector with this matrix.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../org/bitfountain/math/Vector.html" title="class in org.bitfountain.math">Vector</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#mul(org.bitfountain.math.Vector)">mul</A></B>(<A HREF="../../../org/bitfountain/math/Vector.html" title="class in org.bitfountain.math">Vector</A>&nbsp;input)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Multiply this matrix with a vector.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/bitfountain/math/Matrix.html#toString()">toString</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>equals, getClass, hashCode, notify, notifyAll, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="data"><!-- --></A><H3>
data</H3>
<PRE>
public int[][] <B>data</B></PRE>
<DL>
<DD>List of rows, address like this: data[row][column].
<P>
<DL>
</DL>
</DL>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="Matrix(int, int, org.bitfountain.math.reedsolomon.GaloisField)"><!-- --></A><H3>
Matrix</H3>
<PRE>
public <B>Matrix</B>(int&nbsp;rows,
              int&nbsp;cols,
              <A HREF="../../../org/bitfountain/math/reedsolomon/GaloisField.html" title="class in org.bitfountain.math.reedsolomon">GaloisField</A>&nbsp;pGaloisField)</PRE>
<DL>
<DD>Creates a new Matrix.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>rows</CODE> - number of rows<DD><CODE>cols</CODE> - number of columns<DD><CODE>pGaloisField</CODE> - the Galois field the computations are made into</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="gauss()"><!-- --></A><H3>
gauss</H3>
<PRE>
public final void <B>gauss</B>()</PRE>
<DL>
<DD>Naive implementation of Gauss reduction.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="gaussBuster(int)"><!-- --></A><H3>
gaussBuster</H3>
<PRE>
public final void <B>gaussBuster</B>(int&nbsp;identitySize)
                       throws <A HREF="../../../org/bitfountain/math/SingularMatrixException.html" title="class in org.bitfountain.math">SingularMatrixException</A></PRE>
<DL>
<DD>Specialized gauss algorithm for matrices that are almost identity.
 
 Its behavior is documented in the report accompanying this project.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>identitySize</CODE> - Size of the quasi-identity matrix inside this matrix.
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../org/bitfountain/math/SingularMatrixException.html" title="class in org.bitfountain.math">SingularMatrixException</A></CODE> - In case we can't reduce this matrix with gauss.</DL>
</DD>
</DL>
<HR>

<A NAME="mul(org.bitfountain.math.Vector)"><!-- --></A><H3>
mul</H3>
<PRE>
public final <A HREF="../../../org/bitfountain/math/Vector.html" title="class in org.bitfountain.math">Vector</A> <B>mul</B>(<A HREF="../../../org/bitfountain/math/Vector.html" title="class in org.bitfountain.math">Vector</A>&nbsp;input)</PRE>
<DL>
<DD>Multiply this matrix with a vector.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>input</CODE> - The vector with which to multiply
<DT><B>Returns:</B><DD>The result of the multiplication with this vector.</DL>
</DD>
</DL>
<HR>

<A NAME="mul(int[], int[])"><!-- --></A><H3>
mul</H3>
<PRE>
public final void <B>mul</B>(int[]&nbsp;input,
                      int[]&nbsp;output)</PRE>
<DL>
<DD>Multiply a vector with this matrix.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>input</CODE> - Vector to multiply<DD><CODE>output</CODE> - Vector in which to store the result</DL>
</DD>
</DL>
<HR>

<A NAME="getCols()"><!-- --></A><H3>
getCols</H3>
<PRE>
public final int <B>getCols</B>()</PRE>
<DL>
<DD><DL>

<DT><B>Returns:</B><DD>number of columns</DL>
</DD>
</DL>
<HR>

<A NAME="getRows()"><!-- --></A><H3>
getRows</H3>
<PRE>
public final int <B>getRows</B>()</PRE>
<DL>
<DD><DL>

<DT><B>Returns:</B><DD>number of rows</DL>
</DD>
</DL>
<HR>

<A NAME="copyInto(org.bitfountain.math.Matrix, int, int)"><!-- --></A><H3>
copyInto</H3>
<PRE>
public final void <B>copyInto</B>(<A HREF="../../../org/bitfountain/math/Matrix.html" title="class in org.bitfountain.math">Matrix</A>&nbsp;destination,
                           int&nbsp;rowIndex,
                           int&nbsp;colIndex)</PRE>
<DL>
<DD>Copies a matrix into another greater one.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>destination</CODE> - the destination matrix<DD><CODE>rowIndex</CODE> - the line where you want to copy your matrix from<DD><CODE>colIndex</CODE> - the column where you want to copy your matrix from</DL>
</DD>
</DL>
<HR>

<A NAME="copyRowInto(int, org.bitfountain.math.Matrix, int, int)"><!-- --></A><H3>
copyRowInto</H3>
<PRE>
public final void <B>copyRowInto</B>(int&nbsp;sourceRow,
                              <A HREF="../../../org/bitfountain/math/Matrix.html" title="class in org.bitfountain.math">Matrix</A>&nbsp;destination,
                              int&nbsp;row,
                              int&nbsp;column)</PRE>
<DL>
<DD>Copies a row from a matrix into another one.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>sourceRow</CODE> - the row number of the source matrix<DD><CODE>destination</CODE> - the destination matrix<DD><CODE>row</CODE> - the row destination<DD><CODE>column</CODE> - the column destination</DL>
</DD>
</DL>
<HR>

<A NAME="toString()"><!-- --></A><H3>
toString</H3>
<PRE>
public final java.lang.String <B>toString</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE>toString</CODE> in class <CODE>java.lang.Object</CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/Matrix.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../org/bitfountain/math/ArrayUtils.html" title="class in org.bitfountain.math"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../org/bitfountain/math/SingularMatrixException.html" title="class in org.bitfountain.math"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?org/bitfountain/math/Matrix.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Matrix.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
